local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 37586 $"):match("%d+"))

if _G.ThreatLib_OUT_OF_DATE or not AceLibrary:IsNewVersion(MAJOR_VERSION, MINOR_VERSION) then
	_G.ThreatLib_OUT_OF_DATE = true
	return
end

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

local c = BB["Attumen the Huntsman"]

local ThreatLibNPCModuleCore = ThreatLib:GetModule("NPCCore")

-- It's important that modules not be enabled by default
ThreatLibNPCModuleCore:SetModuleDefaultState(c, false)
local Attumen = ThreatLibNPCModuleCore:NewModule(c)

local phaseTwoTriggerStrings = {
	["enUS"] = "%s calls for her master!",
	["deDE"] = "%s ruft nach ihrem Meister!",
	["frFR"] = "%s appelle son ma\195\174tre\194\160!",
	["koKR"] = "%s|1이;가; 주인을 부릅니다!",
	["zhTW"] = "%s呼叫他的主人!"
}

local phaseThreeTriggerStrings = {
	["enUS"] = "Come Midnight, let's disperse this petty rabble!",
	["deDE"] = "Komm Mittnacht, lass' uns dieses Gesindel auseinander treiben!",
	["frFR"] = "Viens, Minuit, allons disperser cette insignifiante racaille\194\160!",
	["koKR"] = "이랴! 이 오합지졸을 데리고 실컷 놀아보자!",
	["zhTW"] = "來吧午夜，讓我們驅散這群小規模的烏合之眾!"
}

function Attumen:Init()
	local phaseTwo = phaseTwoTriggerStrings[_G.GetLocale()]
	phaseTwoTriggerStrings = nil

	local phaseThree = phaseThreeTriggerStrings[_G.GetLocale()]
	phaseThreeTriggerStrings = nil
	
	-- You can register Joe The Noob as a combatant in this fight, and set a handler to be called on his death
	-- self:RegisterCombatant(BB["Joe the Noob"], self.HandleJoeDeath)
	
	-- Alternately, if the second parameter is true, then the fight is over when Joe dies.
	-- self:RegisterCombatant(BB["Joe the Noob"], true)

	self:RegisterCombatant(BB["Midnight"])
	self:RegisterCombatant(BB["Attumen the Huntsman"], true)

	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	-- self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
	
	self:RegisterChatEvent("emote", BB["Midnight"], phaseTwo, self.PhaseTwo)
	self:RegisterChatEvent("yell", BB["Attumen the Huntsman"], phaseThree, self.PhaseThree)
end

-- StartFight is called when you engage any of the mobs registered by RegisterCombatant()
-- Use it to reset any state that you need to maintain in the module (like self.SetNumberOfMobs)
function Attumen:StartFight()
	-- SetNumberOfMobs is used as a divisor for global threat. Be sure to set it correctly, and to account for mob deaths during the fight
	-- If you are unsure of the participants, or you want to just be safe, leave this at 1
	self:SetNumberOfMobs(1)
end

function Attumen:PhaseTwo()
	self:SetNumberOfMobs(2)
end

function Attumen:PhaseThree()
	self:SetNumberOfMobs(1)
	self:WipeRaidThreat("Attumen the Huntsman")
end
